/*
 * Copyright 2016 - 2022 Gary Talent (gary@drinkingtea.net). All rights reserved.
 */

#pragma once

#include <ox/claw/claw.hpp>
#include <ox/model/typestore.hpp>

#include "context.hpp"

namespace nostalgia::core {

class TypeStore: public ox::TypeStore {
	private:
		ox::FileSystem *m_fs = nullptr;

	public:
		constexpr explicit TypeStore(ox::FileSystem *fs) noexcept: m_fs(fs) {
		}

	protected:
		ox::Result<ox::UniquePtr<ox::DescriptorType>> loadDescriptor(const ox::String &name) noexcept override {
			constexpr auto descPath = "/.nostalgia/type_descriptors";
			auto path = ox::sfmt("{}/{}", descPath, name);
			oxRequire(buff, m_fs->read(path));
			auto dt = ox::make_unique<ox::DescriptorType>();
			oxReturnError(ox::readClaw<ox::DescriptorType>(buff, dt.get()));
			return dt;
		}
};

}
